#!/usr/bin/env python

import SpecReduceUtils
import USERDefs


import numpy as np
import matplotlib.pyplot as plt
import math
import copy

##########################
#config variables.
Blue=False
Blue=True 
if (Blue):
  FrmSetup=USERDefs.DBSPBlue
else:
  FrmSetup=USERDefs.DBSPRed
##########################

##########################
#user specified directories. indir will be the input to the header parser
outdir="products/"
extension=".fits"

##########################
#input file stuff.  This will be replaced by the products of the header parser
if (True ):
  print "COMMENT: using evan kirby data"
  indir="data/"
  if (Blue):
    biaslist=[]
    flatlist = ['blue0025','blue0026','blue0027','blue0028','blue0029','blue0030','blue0031','blue0032','blue0033','blue0034']
    #flatlist = ['blue0025','blue0026','blue0027']
    starpack = {'M31-star-7_blue':['blue0089','blue0091','blue0092','blue0093','blue0115','blue0117','blue0118','blue0120']
#               ,'GL905_blue':['blue0095','blue0096','blue0097','blue0098']
#               ,'GL908_blue':['blue0101','blue0102','blue0103']
#               ,'HD38B_blue':['blue0104','blue0105','blue0106']
#               ,'HD38A_blue':['blue0108','blue0109','blue0110']
#               ,'HD1326_blue':['blue0111','blue0112','blue0113']
#               ,'GL109_blue':['blue0126','blue0127']
#               ,'HD28343_blue':['blue0130','blue0131']
#               ,'HD245409_blue':['blue0134','blue0135']
#               ,'HD42581_blue':['blue0139','blue0140']
#               ,'GL239_blue':['blue0141','blue0142']
#               ,'Hiltner600_blue':['blue0145','blue0146']
               ,'Feige34_blue':['blue0147','blue0148']
               }
    telluric = []
    #starlist = ['blue0092'] #M31-star-7_blue
    wavecalibrationlist = ['blue0090','blue0094','blue0099','blue0100','blue0116','blue0119']  #FeAr
    lamps = ['fear.dat']                 #create a table that has lookups for reference files based on header info
    calibrationFile = None
    #lamps = ['fear_specatlas_50.dat']
    #lamps = ['fear_lite.dat']
  else:
    biaslist=[]
    #flatlist = ['red0025','red0026','red0027','red0028','red0029','red0030','red0031','red0032','red0033','red0034']
    flatlist = ['red0025','red0026','red0027']
    starpack = {'M31-star-7_red':['red0089','red0091','red0092','red0093','red0115','red0117','red0118','red0120']
#               ,'GL905_red':['red0095','red0096','red0097','red0098']
#               ,'GL908_red':['red0101','red0102','red0103']
#               ,'HD38B_red':['red0104','red0105','red0106']
#               ,'HD38A_red':['red0108','red0109','red0110']
#               ,'HD1326_red':['red0111','red0112','red0113']
#               ,'GL109_red':['red0126','red0127']
#               ,'HD28343_red':['red0130','red0131']
#               ,'HD245409_red':['red0134','red0135']
#               ,'HD42581_red':['red0139','red0140']
#               ,'GL239_red':['red0141','red0142']
#               ,'Hiltner600_red':['red0145','red0146']
               ,'Feige34_red':['red0147','red0148']
               }
    telluric = ['red0147','red0148']
    #starlist = ['red0092'] #M31-star-7_red
    wavecalibrationlist = ['red0090','red0094','red0099','red0100','red0116','red0119']  #HeNeAr
    calibrationFile = None
    lamps=['henear.dat']
if (False):
  print "COMMENT: using Yi galaxy embedded data"
  indir="GalaxySubeasy/"
  if (Blue):
    biaslist=[]
    calibrationFile = None
    lamps=['fear.dat']
    flatlist=['blue0015','blue0016','blue0017','blue0018','blue0019','blue0020','blue0021','blue0022','blue0023','blue0024']
    wavecalibrationlist = ['blue0011','blue0012']
    starpack={'BD+332642':['blue0035','blue0036']
             ,'iPTF13ast':['blue0039','blue0040','blue0041']
             ,'iPTF13bvn':['blue0045']
             }
  else:
    biaslist=[]
    calibrationFile = None
    lamps=['henear.dat']
    flatlist=['red0015','red0016','red0017','red0018','red0019','red0020','red0021','red0022','red0023','red0024']
    wavecalibrationlist = ['red0011','red0012']
    starpack={'BD+332642':['red0035','red0036']
             ,'iPTF13ast':['red0039','red0040','red0041']
             ,'iPTF13bvn':['red0045']
             }
if (False):
  indir="DBSP_Data/Ashish/20150905UT/"
  print "COMMENT: using ashish data"
  if (Blue):
    lamps=['fear.dat']
    calibrationFile = None
    biaslist = ['blue1001','blue1002','blue1003','blue1004','blue1005','blue1030','blue1031','blue1052','blue1053','blue1094','blue1095']
    wavecalibrationlist=['blue1006','blue1007','blue1008','blue1009'] #FeAr
    #wavecalibrationlist=['blue1010','blue1011','blue1012','blue1013'] #Ar
    #wavecalibrationlist=['blue1014','blue1015','blue1016','blue1017','blue1018','blue1019','blue1020','blue1021'] #He
    #wavecalibrationlist=['blue1022','blue1023','blue1024','blue1025'] #Ne
    #wavecalibrationlist=['blue1026','blue1027','blue1028','blue1029'] #Hg
    flatlist=['blue1032','blue1033','blue1034','blue1035','blue1036','blue1037','blue1038','blue1039','blue1040'#,'blue1041' #blue1041 is malformed
             ,'blue1042','blue1043','blue1044','blue1045','blue1046','blue1047','blue1048','blue1049','blue1050','blue1051']
    starpack = {'J1706+3214':['blue1054']
               ,'J1701+3934':['blue1055']
               ,'J1706+3709':['blue1056']
               ,'J1704+2109':['blue1057']
               ,'J1711+2929':['blue1058','blue1061']
               ,'BD28+4211':['blue1059','blue1060','blue1068','blue1069','blue1079','blue1080']
               ,'J1723+3411':['blue1062','blue1063']
               ,'J2051-0702':['blue1064']
               ,'J2118-0636':['blue1065']
               #,'J2128-0755':['blue1066'] malformed header
               ,'J2133-0712':['blue1067']
               ,'J2133-0712':['blue1067']
               ,'J2221-1111':['blue1070']
               ,'J2222+1959':['blue1071']
               ,'J2231+2519':['blue1072']
               ,'J2236+1343':['blue1073']
               ,'J2254+1136':['blue1074']
               ,'J2255+1457':['blue1075']
               ,'J2335+2934':['blue1076']
               ,'J2344+1221':['blue1077']
               ,'J2346+1517':['blue1078']
               ,'J0000+0923':['blue1081']
               ,'J0009+0909':['blue1082']
               ,'J0029+3841':['blue1083']
               ,'NGC 660':['blue1084']
               ,'J0140+2913':['blue1085']
               ,'J0203-0843':['blue1086']
               ,'J0317+1525':['blue1087']
               ,'J0411+1324':['blue1088']
               ,'J0435-1643':['blue1089']
               ,'PG0310+14':['blue1090','blue1091']
               ,'J0248+0641':['blue1092']
               ,'J0207+2930':['blue1093']
               }
  else:
    lamps=['missing']
    calibrationFile = None
    biaslist = ['red1001','red1002','red1003','red1004','red1005','red1030','red1031','red1052','red1053','red1094','red1095']
    #wavecalibrationlist=['red1006','red1007','red1008','red1009'] #FeAr
    #wavecalibrationlist=['red1010','red1011','red1012','red1013'] #Ar
    #wavecalibrationlist=['red1014','red1015','red1016','red1017','red1018','red1019','red1020','red1021'] #He
    #wavecalibrationlist=['red1022','red1023','red1024','red1025'] #Ne
    #wavecalibrationlist=['red1026','red1027','red1028','red1029'] #Hg
    flatlist=['red1032','red1033','red1034','red1035','red1036','red1037','red1038','red1039','red1040','red1041'
             ,'red1042','red1043','red1044','red1045','red1046','red1047','red1048','red1049','red1050','red1051']
    starpack = {'J1706+3214':['red1054']
               ,'J1701+3934':['red1055']
               ,'J1706+3709':['red1056']
               ,'J1704+2109':['red1057']
               ,'J1711+2929':['red1058','red1061']
               ,'BD28+4211':['red1059','red1060','red1068','red1069','red1079','red1080']
               ,'J1723+3411':['red1062','red1063']
               ,'J2051-0702':['red1064']
               ,'J2118-0636':['red1065']
               ,'J2128-0755':['red1066']
               ,'J2133-0712':['red1067']
               ,'J2133-0712':['red1067']
               ,'J2221-1111':['red1070']
               ,'J2222+1959':['red1071']
               ,'J2231+2519':['red1072']
               ,'J2236+1343':['red1073']
               ,'J2254+1136':['red1074']
               ,'J2255+1457':['red1075']
               ,'J2335+2934':['red1076']
               ,'J2344+1221':['red1077']
               ,'J2346+1517':['red1078']
               ,'J0000+0923':['red1081']
               ,'J0009+0909':['red1082']
               ,'J0029+3841':['red1083']
               ,'NGC 660':['red1084']
               ,'J0140+2913':['red1085']
               ,'J0203-0843':['red1086']
               ,'J0317+1525':['red1087']
               ,'J0411+1324':['red1088']
               ,'J0435-1643':['red1089']
               ,'PG0310+14':['red1090','red1091']
               ,'J0248+0641':['red1092']
               ,'J0207+2930':['red1093']
               }
if (False):
  indir="DBSP_Data/Yi/DBSP_20150925/"
  print "COMMENT: using Yi data"
  if (Blue):
    lamps=['fear.dat']
    calibrationFile = None
    wavecalibrationlist=['blue0001','blue0002','blue0003','blue0004','blue0005','blue0016','blue0017','blue0018','blue0019'
                        ,'blue0020','blue0021','blue0049','blue0050','blue0061','blue0069','blue0074','blue0079','blue0088'
                        ,'blue0095','blue0107','blue0108','blue0111','blue0123'] #FeAr
    biaslist = ['blue0006','blue0007','blue0008','blue0009','blue0010','blue0011','blue0012','blue0013','blue0014','blue0015']
    flatlist=['blue0022','blue0023','blue0023','blue0024','blue0025','blue0026','blue0027','blue0028','blue0029','blue0030'
             ,'blue0031','blue0032','blue0033','blue0034','blue0035','blue0036','blue0037','blue0038','blue0039','blue0040'
             ,'blue0041','blue0042','blue0043','blue0044','blue0124','blue0125','blue0126','blue0127','blue0128','blue0129'
             ,'blue0130','blue0131','blue0132','blue0133','blue0134']
    starpack = {'test':['blue0045','blue0046']
               ,'HD149':['blue0047','blue0048']
               ,'1516bk':['blue0051','blue0052','blue0053','blue0054','blue0055','blue0056','blue0057','blue0058','blue0059','blue0060']
               ,'15dcn':['blue0062']
               ,'15dcm':['blue0063']
               ,'1500ck':['blue0064']
               ,'1523ag':['blue0065','blue0066','blue0067','blue0068','blue0076','blue0077','blue0078','blue0090','blue0091'
                         ,'blue0092','blue0093','blue0094']
               ,'1501cb':['blue0070','blue0071','blue0072','blue0073','blue0080','blue0081','blue0082','blue0083','blue0084'
                         ,'blue0085','blue0086','blue0087','blue0104','blue0105','blue0106']
               ,'15dcs':['blue0075']
               ,'15dcw':['blue0089']
               ,'15dcx':['blue0096']
               ,'15dcy':['blue0097']
               ,'1500cl':['blue0098']
               ,'15dda':['blue0099']
               ,'G191B2B':['blue0100','blue0101','blue0102','blue0103']
               ,'1508bo':['blue0109','blue0110']
               ,'1508bk':['blue0112','blue0113','blue0114','blue0115','blue0116','blue0117','blue0118','blue0119','blue0120']
               ,'blank':['blue0121']
               ,'PS15cci':['blue0122']
               }  
  else:
    lamps=['henear.dat']
    calibrationFile = None
    wavecalibrationlist=['red0001','red0002','red0003','red0004','red0005','red0016','red0017','red0018','red0019'
                        ,'red0020','red0021','red0049','red0050','red0061','red0069','red0074','red0079','red0088'
                        ,'red0095','red0107','red0108','red0111','red0123'] #FeAr
    biaslist = ['red0006','red0007','red0008','red0009','red0010','red0011','red0012','red0013','red0014','red0015']
    flatlist=['red0022','red0023','red0023','red0024','red0025','red0026','red0027','red0028','red0029','red0030'
             ,'red0031','red0032','red0033','red0034','red0035','red0036','red0037','red0038','red0039','red0040'
             ,'red0041','red0042','red0043','red0044','red0124','red0125','red0126','red0127','red0128','red0129'
             ,'red0130','red0131','red0132','red0133','red0134']
    starpack = {'test':['red0045','red0046']
               ,'HD149':['red0047','red0048']
               ,'1516bk':['red0051','red0052','red0053','red0054','red0055','red0056','red0057','red0058','red0059','red0060']
               ,'15dcn':['red0062']
               ,'15dcm':['red0063']
               ,'1500ck':['red0064']
               ,'1523ag':['red0065','red0066','red0067','red0068','red0076','red0077','red0078','red0090','red0091'
                         ,'red0092','red0093','red0094']
               ,'1501cb':['red0070','red0071','red0072','red0073','red0080','red0081','red0082','red0083','red0084'
                         ,'red0085','red0086','red0087','red0104','red0105','red0106']
               ,'15dcs':['red0075']
               ,'15dcw':['red0089']
               ,'15dcx':['red0096']
               ,'15dcy':['red0097']
               ,'1500cl':['red0098']
               ,'15dda':['red0099']
               ,'G191B2B':['red0100','red0101','red0102','red0103']
               ,'1508bo':['red0109','red0110']
               ,'1508bk':['red0112','red0113','red0114','red0115','red0116','red0117','red0118','red0119','red0120']
               ,'blank':['red0121']
               ,'PS15cci':['red0122']
               }  

 





#########################
#testing and processing
biases=[]
bias=None
if biaslist:
  for f in biaslist:
    print "working on ",f
    biasfrm = SpecReduceUtils.Frame(indir+f+extension,type='bias',frameSetup=FrmSetup)
    biases.append(biasfrm)
  #make the medianed bias frame
  if (len(biaslist)>1):
    bias=SpecReduceUtils.frameMedian(biases)
  else:  #there was only one bias frame
    bias = biaslist[0]
  bias.toFile(outdir+FrmSetup['settingName']+"_bias"+extension)

#todo: make this loop into a function in Utils file
flats = []
for f in flatlist:
  print "working on ",f
  flatfrm = SpecReduceUtils.Frame(indir+f+extension,type='flat',bias="*over",frameSetup=FrmSetup)
  #flatfrm = SpecReduceUtils.Frame(indir+f+extension,type='flat',frameSetup=FrmSetup)
  #flatfrm.toFile(outdir+f+"oriented"+extension)
  flats.append(flatfrm)
comboFlat=SpecReduceUtils.frameMedian(flats)
comboFlat.toFile(outdir+FrmSetup['settingName']+"_combindedFlat"+extension)
respFrame=SpecReduceUtils.response(comboFlat,countThreshold=1000)
respFrame.toFile(outdir+FrmSetup['settingName']+"_response"+extension)
#print "DEBUG: response shape: ",respFrame.Data.shape," should equal comboFlat shape: ",comboFlat.Data.shape
flatFrm=SpecReduceUtils.frameDivision(comboFlat,respFrame)
flatFrm.type='flat'
flatFrm.toFile(outdir+FrmSetup['settingName']+"_Flat"+extension)

calibration=[]
if (calibrationFile==None):
  #todo: make this a function in Utils file
  calspectra=[]
  thetaConstant=True
  grateConstant=True
  theta=None
  grate=None
  for f in wavecalibrationlist:
    print "calibrating wavelengths with ",f
    frm=SpecReduceUtils.Frame(indir+f+extension,type='lamp',frameSetup=FrmSetup,loadMode='badpixDebias',bias=bias)
    spec = SpecReduceUtils.simpleExtract(frm.Data)
    SpecReduceUtils.savelist(spec,outdir+f+"_simpleSpectrum.dat")
    calspectra.append(spec)
    #print "for ",f," theta:",SpecReduceUtils.radiansFromString(frm.Head['angle']),"   and grating:",SpecReduceUtils.gratingFromString(frm.Head['grating'])
    if (theta == None):
      theta = SpecReduceUtils.radiansFromString(frm.Head['angle'])
    if (grate == None):
      grate = SpecReduceUtils.gratingFromString(frm.Head['grating'])
    thetaConstant = thetaConstant and (theta == SpecReduceUtils.radiansFromString(frm.Head['angle']))
    grateConstant = grateConstant and (grate == SpecReduceUtils.gratingFromString(frm.Head['grating']))
  if (not (thetaConstant and grateConstant)):
    raise Exception("internally inconsistant calibration files.  please check that all wavelength calibration images have same angle and grating.")
  calibrationSpectrum = np.median(calspectra,0)
  SpecReduceUtils.savelist(calibrationSpectrum,outdir+FrmSetup['settingName']+"_calibrationSpectrum.dat")
  foundPeaks = SpecReduceUtils.findPeaks(calibrationSpectrum,spectralFitSpan=FrmSetup['illuminatedSpan'])
  SpecReduceUtils.savelist(foundPeaks,outdir+FrmSetup['settingName']+"_extractedLampPeaks.dat")
  referencePeaks = SpecReduceUtils.loadLamps([FrmSetup['lampFile']])
  if (USERDefs.MODE['interactiveCalibrateWL']):
    print "use user selected peak,wavelength pairs to calibrate"
    initialPairs = SpecReduceUtils.interactiveCalibrationCollector(calibrationSpectrum,framepitch=frm.pitch,refPeaks=referencePeaks)
    #BYPASS values for getting rapid debug iterations
    #initialPairs = {705: 3576.6156, 835: 3718.2065, 965: 3859.9114, 850: 3734.8636, 2263: 5269.5366, 1656: 4609.5673, 1628: 4579.3495} #YiBlue
    #initialPairs = {2308: 5269.5366, 750: 3576.6156, 879: 3718.2065, 1009: 3859.9114, 1700: 4609.5673, 1949: 4879.8635}  #ashishBlue
    #initialPairs = {2436: 5269.5366, 878: 3576.6156, 1007: 3718.2065, 1137: 3859.9114, 2076: 4879.8635} #broad initial set blue
    #initialPairs = {1809: 4589.8978, 1827: 4609.5673, 1817: 4598.7627, 1799: 4579.3495} #compact quad blue
    #initialPairs = {2632: 7635.105, 2744: 7723.8, 1123: 6402.246, 1814: 6965.43, 1462: 6678.2}  #red broad set
  else:
    dispersionGuess = SpecReduceUtils.computeDispersion(FrmSetup['fixedAngle'],theta,FrmSetup['pixelSize'],FrmSetup['focalLength'],grate)
    #centralLambda = SpecReduceUtils.computeCentralWL(theta,grate)
    centralLambda = SpecReduceUtils.computeCentralWL(theta,grate,FrmSetup['fixedAngle'])
    print "variables for initial calibration:  angle:",FrmSetup['fixedAngle']," pixelSize:",FrmSetup['pixelSize']," focalLength:",FrmSetup['focalLength']," grating:",grate," theta:",theta
    print "approx dispersion as computed from properties: ",dispersionGuess, "   and central WL: ",centralLambda
    initialCalibration = SpecReduceUtils.initialCalibration(dispersionGuess,centralLambda,len(calibrationSpectrum))
    #print "sanity check: ",initialCalibration[0],"  :  ",initialCalibration[-1]
    SpecReduceUtils.savelist(initialCalibration,outdir+FrmSetup['settingName']+"_initialCalibration.dat")
    #debug
    sortP = sorted(foundPeaks)
    initCalPeaks = initialCalibration[sortP]
    print "Rough calibration of found peaks from lamp image:\n",initCalPeaks
    print "reference peaks:\n",referencePeaks
    #end debug
    initialPairs = SpecReduceUtils.calibrateWavelength(foundPeaks,referencePeaks,initialCalibration)
    print "result of correlation calibration:",initialPairs
  #should have the initial pairs of peak->WL.  expand upon this to develop the calibration
  finalPairs = SpecReduceUtils.expandCalibration(initialPairs,foundPeaks,referencePeaks)
  print "result of expanded calibration:",finalPairs
  #fitx=[pixel for pixel in finalPairs]
  #fity=[finalPairs[pixel] for pixel in finalPairs]
  #fitx.sort()
  #fity.sort()
  #calfit = SpecReduceUtils.fit1DNonuniform(fity,fitx,order=max(len(finalPairs)-2,3))
  #calibration = SpecReduceUtils.poly2oneD(calfit,len(calibrationSpectrum))
  calibration = SpecReduceUtils.pairs2Calibration(finalPairs,len(calibrationSpectrum))
  SpecReduceUtils.savelist(calibration,outdir+FrmSetup['settingName']+"_calibration.dat")
else:
  calibration = SpecReduceUtils.loadlist(calibrationFile)

if (telluric):
  telluricSpecs=[]
  telluricVars =[]
  for f in telluric:
    print "STATUS: working on telluric star ",f,"."
    frm = SpecReduceUtils.Frame(indir+f+extension,type='data',frameSetup=FrmSetup,loadMode='badpixDebias',bias=bias)
    flattened = SpecReduceUtils.frameDivision(frm,flatFrm)
    flattened.Head = copy.deepcopy(frm.Head)
    flattened.Head['History'] = "Flattened"
    flattened.toFile(outdir+f+"_Debiased_Flattened"+extension)
    #if (False): #make false for slow computer testing speed up, just leave the cosmics in place...
    if (True ): #make false for slow computer testing speed up, just leave the cosmics in place...
      decosmiced,cosmicMsk = SpecReduceUtils.removeCosmics(flattened)
      decosmiced.toFile(outdir+f+"_Debiased_Flattened_Decosmiced"+extension)
      cosmicMsk.toFile(outdir+f+"_CosmicMask"+extension)
    else:
      decosmiced = flattened
    specs,varis = SpecReduceUtils.optimalExtractWrapper(decosmiced,FrmSetup,USERDefs.MODE['interactiveExtract'],name=f,calibration=calibration)
    telluricSpecs.append(specs[0])
    telluricVars.append(varis[0])
  tSpecs = np.array(telluricSpecs)
  telluricSpec=np.median(tSpecs,0)
  tVars = np.array(telluricVars)
  telluricVar=np.median(tVars,0)
  telluricCorrection=SpecReduceUtils.computeTelluric(telluricSpec,calibration,USERDefs.DBSPConstants['telluricRegions'])
else:
  #use ones so that the correction factor is null
  telluricCorrection = [1 for i in calibration]

SpecReduceUtils.savelist(telluricCorrection,outdir+"telluricCorrection.dat")

for star in starpack: 
  starlist = starpack[star]
  spectra=[]
  variances=[]
  numObjOnFrm=0
  print "STATUS: working on ",star
  for f in starlist:
    print "STATUS: working on ",f," from object:",star
    frm = SpecReduceUtils.Frame(indir+f+extension,type='data',frameSetup=FrmSetup,loadMode='badpixDebias',bias=bias)
    flattened = SpecReduceUtils.frameDivision(frm,flatFrm)
    flattened.Head = copy.deepcopy(frm.Head)
    flattened.Head['History'] = "Flattened"
    flattened.toFile(outdir+f+"_Debiased_Flattened"+extension)
    #if (False): #make false for slow computer testing speed up, just leave the cosmics in place...
    if (True ): #make false for slow computer testing speed up, just leave the cosmics in place...
      decosmiced,cosmicMsk = SpecReduceUtils.removeCosmics(flattened)
      decosmiced.toFile(outdir+f+"_Debiased_Flattened_Decosmiced"+extension)
      cosmicMsk.toFile(outdir+f+"_CosmicMask"+extension)
    else:
      decosmiced = flattened
    specs,varis = SpecReduceUtils.optimalExtractWrapper(decosmiced,FrmSetup,USERDefs.MODE['interactiveExtract'],name=f,calibration=calibration,telluric=telluricCorrection)
    #specs = SpecReduceUtils.optimalExtractWrapper(decosmiced,FrmSetup,USERDefs.MODE['interactiveExtract'],name=f,calibration=None)
    spectra.append(specs)    #this will malfunction when the spectra of the same object in multiple frames are not in the same 
    variances.append(varis)  #  rank in terms of profile brightness
    if len(specs)>numObjOnFrm:
      numObjOnFrm = len(specs)
  #median combine the spectra for this star, plot, and save
  print "DEBUG: combining ",numObjOnFrm," spectra for ",star
  speclist=[]
  varlist=[]
  for i in range(numObjOnFrm):
    speclist.append([])
    varlist.append([])
  for f in spectra:
    for i in range(len(f)):
      speclist[i].append(f[i])
  for f in variances:
    for i in range(len(f)):
      varlist[i].append(f[i])
  for j in range(len(speclist)):
    if len(starlist) > len(speclist[j]):
      print "DEBUG: not all frames had same number of extractions. ",len(starlist)," frames yielded ",len(speclist[j])," spectra of rank ",j,"."
    npSpecs = np.array(speclist[j])
    print "DEBUG: shape of npSpecs:",npSpecs.shape
    spec = np.median(npSpecs,0)
    SpecReduceUtils.savelist(spec,outdir+star+"-spectrum-"+str(j+1)+".dat")
    npVars = np.array(varlist[j])
    var = np.median(npVars,0)
    SpecReduceUtils.savelist(var,outdir+star+"-varianceSpectrum-"+str(j+1)+".dat")
    plt.title("Median Spectrum of "+star+"-"+str(j))
    plt.ylabel("intensity?")
    plt.xlabel("wavelength")
    plt.plot(calibration,spec,'b-')
    plt.savefig(outdir+star+"-optimalSpectrum-"+str(j+1)+".png")
    if (USERDefs.display):
      plt.show()
    plt.clf()
    plt.title("Median Variance Spectrum of "+star+"-"+str(j))
    plt.ylabel("Variance")
    plt.xlabel("wavelength")
    plt.plot(calibration,var,'b-')
    plt.savefig(outdir+star+"-varianceSpectrum-"+str(j+1)+".png")
    plt.clf()



