#This file is intended for holding the DBSP version of variables that will vary from one instrument to another

import math

debug=False

BadPixelValue=65000
BadPixelWarningFraction=.05

MODE={'interactiveCalibrateWL':True 
  ,'interactiveExtract':False 
  }


DBSPBlue={'settingName':'DBSPBlue'
  ,'roll':0
  ,'pitch':1
  ,'yaw':0
  ,'overscan':[407,450]
  ,'biasaxis':1
  ,'fixedAngle':math.pi*38.5/180
  ,'focalLength':228.6
  ,'pixelSize':15
  ,'illuminatedSpan':[300,1700]  #find where flat image drops to near bias levels, and use that.  If not specified
  #,'illuminatedSpan':[1135,2535]  #find where flat image drops to near bias levels, and use that.  If not specified
  ,'spatialFitSpan':[78,375]
#  ,'lampFile':'reference/fear.dat'
  }
DBSPRed={'settingName':'DBSPRed'
  ,'roll':0
  ,'pitch':1
  ,'yaw':1
  ,'overscan':[4125,4141]
  ,'biasaxis':0
  ,'fixedAngle':math.pi*35.0/180
  ,'focalLength':304.8
  ,'pixelSize':15
  ,'illuminatedSpan':[21,3000]  #find where flat image drops to near bias levels, and use that.  If not specified
  ,'spatialFitSpan':[10,202]
#  ,'lampFile':'reference/henear.dat'
  }

DBSPConstants={'telluricRegions':[[6864,6932],[7162,7320],[7591,7703],[8128,8351],[8938,9100]],
               'goodSkyLines':[5460.7348,5577.345,6300.32,6363.81,6553.61,6923.21,6949.03,7571.75,7794.12,7821.51,8399.16,8430.17,8885.83,8919.61],
               'referenceDir':"/Users/dailey/Box Sync/WORK/Spectroscopy/specreduce/reference",
               'lampBits':['D-fileNotSpecified','fear.dat','hg.dat','ar.dat','ne.dat','he.dat','incand-fileNotSpecified']  #D-FeAr-Hg-Ar-Ne-He-InCand
              }

display=False
saveall=True
savepath='products/'
extension='.fits'
maxExtractIter = 20
extractConvergenceVal = .5
