#!/usr/bin/env python

import SpecReduceUtils
import USERDefs
import sys
import getopt
import os
import glob

def main(argv):
  inputdir = ''
  outputfile = ''
  try:
    opts, args = getopt.getopt(argv,"hi:o:",["indir=","output="])
  except getopt.GetoptError:
    print 'specSetup.py -i <indir> -o <output>'
    sys.exit(2)
  for opt, arg in opts:
    if opt == '-h':
      print 'specSetup.py -i <indir> -o <output>'
      sys.exit()
    elif opt in ("-i", "--indir"):
      inputdir = arg
    elif opt in ("-o", "--output"):
      outputfile = arg
    else:
      assert False, "unhandled option on command line"
  print 'Input directory is "', inputdir
  print 'Output file is "', outputfile
  absin=os.path.abspath(inputdir)
  #get files in input directory
  files = [os.path.join(absin,f) for f in os.listdir(absin) if os.path.isfile(os.path.join(absin,f))]
  fitsfiles = [f for f in files if (SpecReduceUtils.splitPathExt(f)[2] == ".fits")]
  inputStruct = SpecReduceUtils.files2Input(fitsfiles)
  SpecReduceUtils.toInput(outputfile,inputStruct)
  

if __name__ == "__main__":
  main(sys.argv[1:])


